﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win.UltraWinGrid;

namespace WinGrid_Column_Order_CS
{
    internal class WinGridColumnPositioner
    {
        private UltraGridBand band;
        private Dictionary<int, UltraGridColumn> columnPositions = new Dictionary<int,UltraGridColumn>();

        public void AddColumnPosition(UltraGridColumn column, int visiblePosition)
        {
            if (this.band == null)
                this.band = column.Band;

            if (column.Band != this.band)
                throw new ArgumentException("All columns added to the positioner must be from the same band");

            if (this.columnPositions.Values.Contains(column))
                throw new ArgumentException("Cannot add the same column to the list twice");

            this.columnPositions.Add(visiblePosition, column);
        }

        public void Position()
        {
            int columnCount = this.columnPositions.Count;
            if(columnCount == 0)
                throw new InvalidOperationException("There are no columns to position");

            int processed = 0;
            int visiblePosition = 0;
            while (processed < columnCount)
            {
                UltraGridColumn column;
                bool success = this.columnPositions.TryGetValue(visiblePosition, out column);
                if (success)
                {
                    column.Header.VisiblePosition = visiblePosition;
                    processed++;
                }
                visiblePosition++;
            }
        }
    }
}
